private import  mango.sys.System;

private import  mango.log.Logger,
                mango.log.Configurator;

private import  mango.cluster.NetworkAlert;

private import  mango.cluster.qos.socket.Cluster;

/*******************************************************************************

        Directive for build.exe to include the winsock2 library

*******************************************************************************/

version (build)
        {
        version (Win32)
                 pragma (link, wsock32);
        }


/*******************************************************************************

        How to send and recieve Alert messages using mango.cluster

*******************************************************************************/

void main()
{
        class Alert : IEventListener
        {
                private ILogger logger;

                /***************************************************************

                        Create an Alert consumer, and send it a message. 
                        The same message is send to all listeners across
                        the local network.

                ***************************************************************/

                this (ICluster cluster)
                {
                        logger = cluster.getLogger();

                        // hook into the Alert layer
                        NetworkAlert alert = new NetworkAlert (cluster, "my.kind.of.alert");

                        // listen for the reply (on this channel)
                        alert.createConsumer (this);

			// say what's going on
			logger.info ("broadcasting alert");

                        // and send everyone an empty alert (on this channel)
                        alert.broadcast ();
                }

                /***************************************************************

                        callback to consume messages

                ***************************************************************/

                void notify (IEvent event, IPayload payload)
                {
                        logger.info ("Recieved message on channel " ~ event.getChannel.getName);
                }
        }


        // configure the main logger
        BasicConfigurator.configure ();
        Logger logger = Logger.getLogger ("example.broadcast");
        logger.info ("press <ctrl-c> to quit");

        // hook into the cluster
        Cluster cluster = new Cluster (logger);

        // demonstrate alerts
        new Alert (cluster);

        // wait for it to arrive ...
        System.sleep ();
}
